import { jsx as a, Fragment as H, jsxs as C } from "react/jsx-runtime";
import { useDispatch as fe, useSelector as Q, Provider as Ee } from "react-redux";
import * as p from "react";
import { useState as xe, useRef as ce, useEffect as Ne } from "react";
import { createSlice as Me, configureStore as Se } from "@reduxjs/toolkit";
import { createPortal as De } from "react-dom";
import je from "classnames";
let ge = class $ extends HTMLElement {
  static get observedAttributes() {
    return ["open"];
  }
  constructor() {
    super(), arguments.length && $.custom.apply(this, arguments);
  }
  get type() {
    return this.getAttribute("type");
  }
  get time() {
    let n = this.getAttribute("time");
    return !isNaN(n) && !isNaN(parseFloat(n)) ? Number(n) : 3e3;
  }
  set type(n) {
    this.setAttribute("type", n);
  }
  set time(n) {
    this.setAttribute("time", n);
  }
  get open() {
    return this.hasAttribute("open");
  }
  set open(n) {
    this.toggleAttribute("open", n);
  }
  connectedCallback() {
    this.setAttribute("tabIndex", 0), this.setAttribute("role", "tooltip"), this.closeMode || (this.closeMode = "hide"), this.addEventListener("click", () => {
      this[this.closeMode]();
    }), this.dispatchEvent(new CustomEvent("connected", {
      detail: {
        type: "ui-lighttip"
      }
    })), this.isConnectedCallback = !0;
  }
  attributeChangedCallback(n, t, o) {
    n == "open" && typeof t != typeof o && (typeof o == "string" ? (clearTimeout(this.timer), this.timer = setTimeout(() => {
      this.isTimeHide = !0, this[this.closeMode](), this.position();
    }, this.time), this.setAttribute("data-tid", this.timer), this.classList.add("ESC"), this.zIndex(), this.position()) : this.classList.remove("ESC"), this.tabIndex(), this.isTimeHide = null);
  }
  zIndex() {
    var n = 19;
    this.parentElement && [...this.parentElement.childNodes].forEach(function(t) {
      if (t.nodeType == 1) {
        var o = window.getComputedStyle(t), r = o.zIndex * 1;
        r && o.display != "none" && (n = Math.max(r + 1, n));
      }
    }), this.style.zIndex = n;
  }
  // 定位处理
  position() {
    var n = [...document.querySelectorAll('ui-lighttip[open]:not([type="loading"])')], t = n.sort(function(s, c) {
      return (s.getAttribute("data-tid") || 0) - (c.getAttribute("data-tid") || 0);
    }), o = {}, r = -1;
    t.forEach((s) => {
      let c = s.textContent;
      typeof o[c] > "u" && (r++, o[c] = r), s.style.setProperty("--ui-sort-index", o[c]);
    });
  }
  // 新的元素层级总是最高
  tabIndex() {
    var n = this, t = $.lastActiveElement;
    if (this.open == !0) {
      var o = document.activeElement;
      o && !o.closest("[keepfocus]") && (n !== o && ($.lastActiveElement = o), n.focus());
    } else
      t && !t.matches("body") && (t.focus({
        preventScroll: !0
      }), !window.isKeyEvent && !this.isTimeHide && t.blur(), $.lastActiveElement = null);
    return this;
  }
  // success
  static success(n, t = 3e3) {
    return this.custom(n, "success", t);
  }
  // error
  static error(n, t = 3e3) {
    return this.custom(n, "error", t);
  }
  // normal
  static normal(n, t = 3e3) {
    return this.custom(n, "normal", t);
  }
  // loading
  static loading(n) {
    return n = n || "正在加载中...", this.custom(n, "loading");
  }
  // 调用方法处理
  static custom(n = "", t, o) {
    if (!this.matches || !this.matches("ui-lighttip"))
      return $.custom.apply(document.createElement("ui-lighttip"), arguments);
    if (typeof n == "object" && (t = n, n = ""), typeof n != "string")
      return this;
    if (this.closeMode = "remove", t && typeof t == "object") {
      $.custom.call(this, n, t.type, t.time);
      return;
    }
    if (typeof t == "number") {
      $.custom.call(this, n, o, t);
      return;
    }
    return t == "loading" && (n || (n = "正在加载中..."), o = 999999), o && (this.time = o), t && (this.type = t), this.innerHTML = n, t == "success" ? this.setAttribute("aria-lable", "操作成功") : t == "error" && this.setAttribute("aria-lable", "操作失败"), this.parentElement || (document.body.appendChild(this), this.dispatchEvent(new CustomEvent("DOMContentLoaded"))), this.show(), this;
  }
  remove() {
    this.parentElement && this.parentElement.removeChild(this), this.open = !1;
  }
  show() {
    this.time > 0 && (this.open = !0);
  }
  hide() {
    this.open = !1;
  }
};
customElements.get("ui-lighttip") || customElements.define("ui-lighttip", ge);
window.LightTip = ge;
class Te {
  static s() {
    return Math.floor((1 + Math.random()) * 65536).toString(16).substring(1);
  }
  static uuid() {
    return this.s() + this.s() + this.s();
  }
  static guid() {
    return this.s() + this.s() + "-" + this.s() + "-" + this.s() + "-" + this.s() + "-" + this.s() + this.s() + this.s();
  }
}
const Ae = (e) => /* @__PURE__ */ p.createElement("svg", { width: 12, height: 12, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M36 19L24 31L12 19H36Z", fill: "#969696", stroke: "#969696", strokeWidth: 4, strokeLinejoin: "miter" }));
var me = /* @__PURE__ */ ((e) => (e.dragging = "dragging", e.stop = "stop", e))(me || {}), _ = /* @__PURE__ */ ((e) => (e.always = "always", e.hover = "hover", e))(_ || {});
const Ie = {
  name: "name",
  key: "id",
  children: "children",
  slot: "slot"
}, $e = (e) => {
  if (e === "downone")
    return /* @__PURE__ */ a(Ae, {});
}, We = {
  fieldNames: Ie,
  reverse: !1,
  contextMenu: !1,
  switcherIcon: () => $e("downone"),
  checkable: !1,
  selectable: !0
}, He = {
  default: {
    theme: "default"
  },
  figma: {
    theme: "figma",
    foldIconDisplay: _.hover,
    draggable: !0,
    contextMenu: !0
  },
  file: {
    theme: "file",
    showLine: !0
  }
}, qe = ".node-name", z = "tree:copy:node", Pe = (e) => Number(e.getAttribute("data-index")), Be = (e) => {
  var n;
  return (n = e.getAttribute("data-anchor")) == null ? void 0 : n.split(",");
}, Oe = (e) => e.getAttribute("data-id"), Ve = (e) => e.querySelector(qe), Ze = (e) => {
  let n = e.target;
  for (; n !== null; ) {
    if (n.getAttribute("data-anchor"))
      return n;
    n = n.parentNode;
  }
}, V = (e, n) => {
  document.querySelector(`[name="${e.join()}"]`).indeterminate = n;
}, ze = () => localStorage.getItem(z), Je = () => {
  localStorage.removeItem(z);
}, Ke = (e) => {
  localStorage.setItem(z, e);
}, Ue = () => !!localStorage.getItem(z), Fe = (e) => {
  const n = Be(e), t = Oe(e), o = Pe(e);
  return { id: t, anchor: n, index: o };
}, y = (e, n) => {
  const { children: t } = W(), o = [];
  return e.forEach((r) => {
    if (r.length === 0)
      return o;
    let s;
    r.forEach((c, l) => {
      l === 0 ? s = n[c] : l !== r.length && s && s[t] && (s = s[t][c]);
    }), s && o.push(s);
  }), o;
}, Ye = (e, n) => {
  const t = e.length;
  for (let o = 0; o < t - 1; o++)
    for (let r = 0; r < t - o - 1; r++) {
      const s = e[r], c = e[r + 1];
      let l = 0;
      for (; l < s.length || l < c.length; ) {
        if (c[l] > s[l] || s[l] === void 0) {
          [e[r], e[r + 1]] = [e[r + 1], e[r]][n[r], n[r + 1]] = [
            n[r + 1],
            n[r]
          ];
          break;
        }
        if (s[l] > c[l])
          break;
        l++;
      }
    }
  return [e, n];
}, Xe = (e) => JSON.parse(JSON.stringify(e)), ke = (e, n) => {
  const { children: t } = W();
  return e.forEach((o, r) => {
    const s = n.slice();
    s.push(r), o.anchor = s.slice(), o[t] && ke(o[t], s);
  }), e;
}, Ge = (e, n) => {
  const t = [];
  let o = !1;
  return e.forEach((r) => {
    const s = n.length > r.length ? r.length : n.length, c = [];
    let l = 0, h = 0;
    for (; l < r.length && h < n.length && r[l] === n[h]; )
      c.push(r[l]), l++, h++;
    c.length === s ? (o = !0, t.findIndex((m) => m.toString() === c.toString()) === -1 && t.push(c)) : t.findIndex((m) => m.toString() === r.toString()) === -1 && t.push(r);
  }), o || t.push(n), t;
}, Qe = () => Te.guid(), _e = () => {
  let e;
  return function() {
    return e || (e = document.querySelector(".tree-context-menu"), e);
  };
}, Re = (e) => {
  const n = e.theme ?? "default";
  window.$tree = {
    ...We,
    ...He[n],
    ...e,
    dragNode: null,
    throttleTimer: 0,
    throttleDelay: 200,
    drag: {
      start: {
        id: "",
        index: 0
      },
      over: !1
      // identify can drop
    },
    style: {
      "--node-indent": (e.indentSize ?? 15) + "px",
      "--parent-bg-color": e.parentBgColor ?? "#e9e9e9",
      "--parent-color": e.parentColor ?? "#000",
      "--children-bg-color": e.childrenBgColor ?? "#f6f4f4",
      "--children-color": e.childrenColor ?? "#000"
    },
    menu: _e()
  };
}, A = () => window.$tree, W = () => {
  const { fieldNames: e } = A();
  return e;
}, et = (e) => e.preventDefault(), B = (e) => e.stopPropagation(), tt = {
  treeData: [],
  status: me.stop,
  start: {
    ids: [],
    anchors: [],
    indexes: [],
    from: ""
  },
  over: {
    id: "",
    anchor: [],
    index: -1
  }
}, ve = Me({
  name: "tree",
  initialState: tt,
  reducers: {
    initTreeData: (e, n) => {
      e.treeData = Xe(n.payload);
    },
    setStart: (e, { payload: n }) => {
      const [t, o, r] = n;
      e.start.ids = t;
      const [s, c] = Ye(o, r);
      e.start.anchors = s, e.start.indexes = c, y(s, e.treeData).forEach((h) => {
        h.selected = !0;
      });
    },
    clearSelected: (e) => {
      const n = y(e.start.anchors, e.treeData);
      n.length && n.forEach((t) => {
        t.selected = !1;
      });
    },
    setOver: (e, { payload: n }) => {
      const [t, o] = n;
      t !== "" && (e.over.anchor = t), o !== void 0 && (e.over.index = o);
    },
    setStatus: (e, { payload: n }) => {
      e.status = n;
    },
    updateNode: (e, { payload: n }) => {
      const [t, o, r] = n;
      y(t, e.treeData).forEach((c) => {
        c[o] = r;
      });
    },
    updateChecked: (e, { payload: n }) => {
      const { children: t } = W(), [o, r] = n, s = y([o], e.treeData)[0];
      s.checked = r;
      const c = (h) => {
        const d = h[t];
        d && (V(h.anchor, !1), d.forEach((m) => {
          m.checked = r, c(m);
        }));
      }, l = (h) => {
        const d = h;
        for (d.pop(); d.length; ) {
          const m = y([d], e.treeData)[0], w = m[t];
          r ? w.find((E) => !E.checked) ? V(d, !0) : (V(d, !1), m.checked = !0) : w.find((E) => E.checked) ? V(d, !0) : (V(d, !1), m.checked = !1), d.pop();
        }
      };
      c(s), l(o);
    },
    refresh: (e) => {
      const { key: n } = W();
      function t(o, r) {
        o == null || o.forEach((s, c) => {
          const l = [...r];
          l.push(c), s.anchor = l.slice();
          const h = e.start.ids.indexOf(s[n]), d = e.over.id === s[n];
          h !== -1 && (e.start.anchors[h] = s.anchor), d && (e.over.anchor = s.anchor), s.children && t(s.children, s.anchor);
        });
      }
      e.treeData.forEach((o, r) => {
        o.anchor = [r];
        const s = e.start.ids.indexOf(o[n]), c = e.over.id === o[n];
        s !== -1 && (e.start.anchors[s] = o.anchor), c && (e.over.anchor = o.anchor), o.children && t(o.children, o.anchor);
      });
    },
    moveNode: (e) => {
      const n = e.start, t = e.over, o = t.anchor.length === 0;
      n.anchors.forEach((r, s) => {
        var M, E, S;
        const c = r.length === 1, l = y([r], e.treeData)[0], h = y([t.anchor], e.treeData)[0];
        let d = e.start.indexes[s];
        if (!h && !o)
          return;
        const m = r.slice();
        m.pop();
        const w = y([m], e.treeData)[0];
        o ? (e.treeData.splice(t.index, 0, l), c ? (d >= t.index && (d += 1), e.treeData.splice(d, 1)) : (M = w.children) == null || M.splice(d, 1)) : ((E = h.children) == null || E.splice(t.index, 0, l), h && (w == null ? void 0 : w.id) === h.id && d >= t.index && (d += 1), c ? e.treeData.splice(d, 1) : (S = w.children) == null || S.splice(d, 1));
      });
    },
    removeNode: (e) => {
      const { children: n } = W();
      e.start.anchors.forEach((t, o) => {
        var r;
        if (t.length === 1)
          e.treeData.splice(e.start.indexes[o], 1);
        else {
          const s = t.slice();
          s.pop(), (r = y([s], e.treeData)[0][n]) == null || r.splice(e.start.indexes[o], 1);
        }
      });
    },
    copyNode: (e) => {
      const n = y(e.start.anchors, e.treeData);
      Ke(JSON.stringify(n));
    },
    pasteNode: (e) => {
      const { key: n, children: t, name: o, slot: r } = W(), s = e.start.anchors[0].slice();
      s.pop();
      const c = ze();
      if (c) {
        const l = JSON.parse(c);
        if (l.forEach((h) => {
          h[n] = Qe(), h[o] = `${h[o]}_Copy`, l.length === 1 && (h.selected = !1);
        }), s.length === 0)
          e.treeData.splice(e.start.indexes[0], 0, l);
        else {
          const h = y([e.start.anchors[0]], e.treeData)[0];
          h[r] === !0 ? h[t].unshift(...l) : y([s], e.treeData)[0][t].splice(e.start.indexes[0], 0, ...l);
        }
        Je();
      }
    }
  }
}), {
  clearSelected: ae,
  updateChecked: nt,
  initTreeData: ot,
  updateNode: le,
  removeNode: de,
  pasteNode: rt,
  setStatus: st,
  copyNode: he,
  moveNode: it,
  setStart: ue,
  setOver: ct,
  refresh: Z
} = ve.actions, at = ve.reducer, R = () => {
  const e = fe(), n = Q((f) => f.tree.start), t = (f) => {
    o();
  }, o = () => {
    const { menu: f, contextMenu: k } = A();
    k !== !1 && (f().style.visibility = "hidden");
  }, r = (f, k, D) => {
    const { selectable: T } = A();
    T !== !1 && (e(ae()), e(ue([f, k, D])));
  }, s = (f, k) => {
    e(ct([f, k]));
  }, c = (f, k) => {
    e(le([[f], "lock", k]));
  }, l = (f, k) => {
    e(le([[f], "hidden", k]));
  }, h = () => {
    e(he()), o(), new LightTip("复制成功", "success");
  }, d = () => {
    e(he()), e(de()), e(Z()), o(), new LightTip("剪切成功", "success");
  }, m = () => {
    e(rt()), e(Z()), o(), new LightTip("粘贴成功", "success");
  }, w = () => {
    e(de()), e(Z()), o(), new LightTip("删除成功", "success");
  }, M = () => {
    e(it()), e(Z());
  }, E = (f) => {
    e(st(f));
  }, S = (f) => {
    const { foldIconDisplay: k } = A();
    k === "hover" && f.currentTarget.classList.add("tree-mouse-in");
  }, L = (f) => {
    const { foldIconDisplay: k } = A();
    k === "hover" && f.currentTarget.classList.remove("tree-mouse-in");
  }, N = () => {
    const { menu: f } = A();
    f().setAttribute("data-paste", String(Ue()));
  }, j = (f, k) => {
    const { menu: D } = A(), T = D().clientHeight, O = document.documentElement.clientHeight;
    let q = k;
    k + T > O && (q = q - T), D().style.left = `${f}px`, D().style.top = `${q}px`, D().style.visibility = "visible";
  };
  return {
    select: r,
    over: s,
    dragStatus: E,
    lock: c,
    hidden: l,
    copy: h,
    cut: d,
    paste: m,
    remove: w,
    move: M,
    mouseEnter: S,
    mouseLeave: L,
    rightClick: (f) => {
      const { contextMenu: k } = A();
      if (k === !1)
        return;
      f.stopPropagation(), f.preventDefault();
      const D = Ze(f);
      if (D) {
        const { id: T, anchor: O, index: q } = Fe(D);
        n.ids.indexOf(T) === -1 && (e(ae()), e(ue([[T], [O], [q]]))), N(), j(f.clientX, f.clientY);
      }
    },
    hideMenu: o,
    handleTreeMouseDown: t,
    checked: (f, k) => {
      e(nt([f, k]));
    }
  };
}, lt = (e) => /* @__PURE__ */ p.createElement("svg", { width: 14, height: 14, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M14 11L4 24L14 37H44V11H14Z", fill: "none", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M21 19L31 29", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M31 19L21 29", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square", strokeLinejoin: "miter" })), dt = (e) => /* @__PURE__ */ p.createElement("svg", { width: 14, height: 14, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M17 7H16H10C8.89543 7 8 7.89543 8 9L8 42C8 43.1046 8.89543 44 10 44H38C39.1046 44 40 43.1046 40 42V9C40 7.89543 39.1046 7 38 7H33.0499H31", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("rect", { x: 17, y: 4, width: 14, height: 6, fill: "none", stroke: "var(--icon)", strokeWidth: 3, strokeLinejoin: "miter" })), ht = (e) => /* @__PURE__ */ p.createElement("svg", { width: 14, height: 14, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M11 42C13.7614 42 16 39.7614 16 37C16 34.2386 13.7614 32 11 32C8.23858 32 6 34.2386 6 37C6 39.7614 8.23858 42 11 42Z", fill: "none", stroke: "var(--icon)", strokeWidth: 3, strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M37 42C39.7614 42 42 39.7614 42 37C42 34.2386 39.7614 32 37 32C34.2386 32 32 34.2386 32 37C32 39.7614 34.2386 42 37 42Z", fill: "none", stroke: "var(--icon)", strokeWidth: 3, strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M15.3774 39.4131L17.5 35.8162L34.5 6.37138", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square" }), /* @__PURE__ */ p.createElement("path", { d: "M13.4957 6.17518L30.4957 35.62L32.6265 39.4131", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square" })), ut = (e) => /* @__PURE__ */ p.createElement("svg", { width: 14, height: 14, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M13 12.4316V7.8125C13 6.2592 14.2592 5 15.8125 5H40.1875C41.7408 5 43 6.2592 43 7.8125V32.1875C43 33.7408 41.7408 35 40.1875 35H35.5163", stroke: "var(--icon)", strokeWidth: 3, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M32.1875 13H7.8125C6.2592 13 5 14.2592 5 15.8125V40.1875C5 41.7408 6.2592 43 7.8125 43H32.1875C33.7408 43 35 41.7408 35 40.1875V15.8125C35 14.2592 33.7408 13 32.1875 13Z", fill: "none", stroke: "var(--icon)", strokeWidth: 3, strokeLinejoin: "miter" }));
const pt = (e) => {
  const { copy: n, paste: t, cut: o, remove: r, contextMenu: s } = e;
  return s ? De(
    /* @__PURE__ */ C(
      "ul",
      {
        onMouseUp: B,
        onMouseDown: B,
        onMouseMove: B,
        onContextMenu: B,
        className: "tree-context-menu",
        "data-paste": "false",
        children: [
          /* @__PURE__ */ C("li", { onClick: () => n == null ? void 0 : n(), children: [
            /* @__PURE__ */ C("span", { className: "menu-item", children: [
              /* @__PURE__ */ a(ut, { className: "i-icon" }),
              "复制"
            ] }),
            /* @__PURE__ */ a("span", { children: "⌘C" })
          ] }),
          /* @__PURE__ */ C("li", { onClick: () => t == null ? void 0 : t(), children: [
            /* @__PURE__ */ C("span", { className: "menu-item", children: [
              /* @__PURE__ */ a(dt, { className: "i-icon" }),
              "粘贴"
            ] }),
            /* @__PURE__ */ a("span", { children: "⌘V" })
          ] }),
          /* @__PURE__ */ C("li", { onClick: () => o == null ? void 0 : o(), children: [
            /* @__PURE__ */ C("span", { className: "menu-item", children: [
              /* @__PURE__ */ a(ht, { className: "i-icon" }),
              "剪切"
            ] }),
            /* @__PURE__ */ a("span", { children: "⌘X" })
          ] }),
          /* @__PURE__ */ C("li", { onClick: () => r == null ? void 0 : r(), children: [
            /* @__PURE__ */ C("span", { className: "menu-item", children: [
              /* @__PURE__ */ a(lt, { className: "i-icon" }),
              "删除"
            ] }),
            /* @__PURE__ */ a("span", { children: "Del" })
          ] })
        ]
      }
    ),
    document.body
  ) : /* @__PURE__ */ a(H, {});
}, ft = ({ name: e, node: n }) => {
  const t = R(), o = (r, s) => {
    const c = s.split(",").map(Number);
    t.checked(c, r);
  };
  return /* @__PURE__ */ a(
    "input",
    {
      name: e,
      type: "checkbox",
      is: "ui-checkbox",
      checked: n.checked,
      onMouseDown: B,
      onClick: (r) => o(r.target.checked, e),
      onChange: () => {
      }
    }
  );
}, gt = (e) => /* @__PURE__ */ p.createElement("svg", { width: 12, height: 12, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M6 16C6.63472 17.2193 7.59646 18.3504 8.82276 19.3554C12.261 22.1733 17.779 24 24 24C30.221 24 35.739 22.1733 39.1772 19.3554C40.4035 18.3504 41.3653 17.2193 42 16", stroke: "#969696", strokeWidth: 4, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M28.9775 24L31.048 31.7274", stroke: "#969696", strokeWidth: 4, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M37.3535 21.3536L43.0103 27.0104", stroke: "#969696", strokeWidth: 4, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M5.00004 27.0103L10.6569 21.3534", stroke: "#969696", strokeWidth: 4, strokeLinecap: "square", strokeLinejoin: "miter" }), /* @__PURE__ */ p.createElement("path", { d: "M16.9278 31.7276L18.9983 24.0001", stroke: "#969696", strokeWidth: 4, strokeLinecap: "square", strokeLinejoin: "miter" })), mt = (e) => /* @__PURE__ */ p.createElement("svg", { width: 12, height: 12, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("path", { d: "M24 36C35.0457 36 44 24 44 24C44 24 35.0457 12 24 12C12.9543 12 4 24 4 24C4 24 12.9543 36 24 36Z", fill: "none", stroke: "#969696", strokeWidth: 4, strokeLinejoin: "round" }), /* @__PURE__ */ p.createElement("path", { d: "M24 29C26.7614 29 29 26.7614 29 24C29 21.2386 26.7614 19 24 19C21.2386 19 19 21.2386 19 24C19 26.7614 21.2386 29 24 29Z", fill: "none", stroke: "#969696", strokeWidth: 4, strokeLinejoin: "round" })), kt = (e) => /* @__PURE__ */ p.createElement("svg", { width: 12, height: 12, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("rect", { x: 7, y: 22.0476, width: 34, height: 22, rx: 2, fill: "none", stroke: "#969696", strokeWidth: 4, strokeLinejoin: "round" }), /* @__PURE__ */ p.createElement("path", { d: "M14 22V14.0047C13.9948 8.87022 17.9227 4.56718 23.0859 4.05117C28.249 3.53516 32.9673 6.97408 34 12.0059", stroke: "#969696", strokeWidth: 4, strokeLinecap: "round", strokeLinejoin: "round" }), /* @__PURE__ */ p.createElement("path", { d: "M24 30V36", stroke: "#969696", strokeWidth: 4, strokeLinecap: "round", strokeLinejoin: "round" })), vt = (e) => /* @__PURE__ */ p.createElement("svg", { width: 12, height: 12, viewBox: "0 0 48 48", fill: "none", ...e }, /* @__PURE__ */ p.createElement("rect", { x: 6, y: 22, width: 36, height: 22, rx: 2, fill: "none", stroke: "#969696", strokeWidth: 4, strokeLinejoin: "round" }), /* @__PURE__ */ p.createElement("path", { d: "M14 22V14C14 8.47715 18.4772 4 24 4C29.5228 4 34 8.47715 34 14V22", stroke: "#969696", strokeWidth: 4, strokeLinecap: "round", strokeLinejoin: "round" }), /* @__PURE__ */ p.createElement("path", { d: "M24 30V36", stroke: "#969696", strokeWidth: 4, strokeLinecap: "round", strokeLinejoin: "round" })), wt = (e) => {
  const { node: n, lock: t, hidden: o } = e;
  return n ? /* @__PURE__ */ C("div", { className: "action", children: [
    /* @__PURE__ */ C(
      "div",
      {
        onMouseDown: (r) => t == null ? void 0 : t(r, n),
        onMouseUp: B,
        className: "lock-wrap",
        children: [
          n.lock ? /* @__PURE__ */ a(vt, { className: `i-lock ${n.lock && "show"}` }) : /* @__PURE__ */ a(kt, { className: "i-unlock" }),
          /* @__PURE__ */ a("span", { className: "lock-dot", children: "·" })
        ]
      }
    ),
    /* @__PURE__ */ C(
      "div",
      {
        onMouseDown: (r) => o == null ? void 0 : o(r, n),
        onMouseUp: B,
        className: "hidden-wrap",
        children: [
          n.hidden ? /* @__PURE__ */ a(gt, { className: `i-invisible ${n.hidden ? "show" : ""}` }) : /* @__PURE__ */ a(mt, { className: "i-visible" }),
          /* @__PURE__ */ a("span", { className: "visible-dot", children: "·" })
        ]
      }
    )
  ] }) : /* @__PURE__ */ a(H, {});
}, pe = (e) => {
  const { indent: n, node: t, virtual: o, switcherIcon: r } = e, { slot: s } = W();
  return t ? /* @__PURE__ */ a("div", { className: "node-indent", children: n == null ? void 0 : n.map((c, l) => /* @__PURE__ */ a("span", { children: !o && l === n.length - 1 && t[s] && /* @__PURE__ */ a(
    "label",
    {
      className: "label-fold",
      htmlFor: `fold-${t.id}`,
      children: r == null ? void 0 : r()
    }
  ) }, l)) }) : /* @__PURE__ */ a(H, {});
}, we = ({ Icom: e, node: n }) => {
  if (!e)
    return /* @__PURE__ */ a(H, {});
  if (typeof e == "string")
    return /* @__PURE__ */ a("i", { className: "icon", children: /* @__PURE__ */ a("img", { src: e }) });
  if (typeof e == "object")
    return /* @__PURE__ */ a(H, { children: e });
  if (typeof we == "function")
    return /* @__PURE__ */ a(e, { ...n });
}, bt = (e) => {
  var te;
  const {
    data: n,
    lineRef: t,
    containerRef: o,
    defaultSelectMulti: r,
    draggable: s,
    checkable: c,
    icon: l,
    switcherIcon: h,
    onDragEnter: d,
    onDragLeave: m,
    onDragOver: w,
    onDrop: M,
    onDragEnd: E,
    onDragStart: S
  } = e, L = n, N = R(), j = Q((u) => u.tree.start), J = (te = o == null ? void 0 : o.current) == null ? void 0 : te.getBoundingClientRect().top, { key: K } = W(), f = (u, g) => {
    u.stopPropagation(), N.lock(g.anchor, !g.lock);
  }, k = (u, g) => {
    u.stopPropagation(), N.hidden(g.anchor, !g.hidden);
  }, D = (u, g, b, i) => {
    u.stopPropagation(), N.select([g], [b], [i]), window.$tree.drag.start.id = g, window.$tree.dragNode = u.currentTarget;
    const x = y([b], L)[0];
    S == null || S({ event: u, node: x });
  }, T = (u, g) => {
    u.stopPropagation(), u.preventDefault();
    const b = y([g], L)[0];
    d == null || d({ event: u, node: b });
  }, O = (u, g, b, i, x, v, P) => {
    var ne, oe, re, se, ie;
    u.stopPropagation(), u.preventDefault();
    const U = y([x], L)[0];
    w == null || w({ event: u, node: U });
    const I = u.currentTarget, F = x.slice();
    if (F.pop(), I.style.boxShadow = "none", window.$tree.drag.over = !0, g || window.$tree.drag.start.id === i) {
      window.$tree.drag.over = !1;
      return;
    }
    if ((re = (oe = (ne = window.$tree.dragNode) == null ? void 0 : ne.parentNode) == null ? void 0 : oe.nextSibling) == null ? void 0 : re.contains(I)) {
      t != null && t.current && (t.current.style.opacity = "0"), window.$tree.drag.over = !1;
      return;
    }
    const Y = u.pageY, X = I.getBoundingClientRect().top, G = X + 30 / 2;
    if (b && i !== window.$tree.drag.start.id && Y > G - 7 && Y < G + 7) {
      t != null && t.current && (t.current.style.opacity = "0"), I.style.boxShadow = "inset 0 0 0px 1px blue", N.over(x, P);
      return;
    }
    if (t != null && t.current && (t.current.style.opacity = "1"), Y > G) {
      const Le = ((ie = (se = I == null ? void 0 : I.nextSibling) == null ? void 0 : se.querySelector("label")) == null ? void 0 : ie.control.checked) === !1;
      if (b && Le && P > 0) {
        t != null && t.current && (t.current.style.opacity = "0"), window.$tree.drag.over = !1;
        return;
      }
      t != null && t.current && (t.current.style.top = `${X - (J || 0) + 30}px`), N.over(F, v);
    } else
      t != null && t.current && (t.current.style.top = `${X - (J || 0)}px`), N.over(F, v + 1);
    t != null && t.current && (t.current.style.left = `${Ve(I).offsetLeft - 10}px`);
  }, q = (u, g) => {
    u.stopPropagation();
    const b = u.currentTarget;
    b.style.boxShadow = "none";
    const i = y([g], L)[0];
    m == null || m({ event: u, node: i });
  }, be = (u, g) => {
    const b = y([g], L)[0];
    E == null || E({ event: u, node: b });
  }, ye = (u, g, b) => {
    u.stopPropagation();
    const i = u.currentTarget;
    if (t != null && t.current && (t.current.style.opacity = "0"), i.style.boxShadow = "none", g || !window.$tree.drag.over)
      return;
    const x = y([b], L)[0], v = y(j.anchors, L);
    M == null || M({ event: u, node: x, dragNodes: v, dragNodesKeys: j.anchors }), N.move();
  }, Ce = (u, g, b, i) => {
    if (!(j.ids.includes(g) || u.button === 2)) {
      if (u.metaKey && r) {
        const x = [...j.ids, g], v = Ge(j.anchors, b), P = v.map((U) => U.slice().pop());
        N.select(x, v, P);
        return;
      }
      N.select([g], [b], [i]);
    }
  };
  if (!(L != null && L.length))
    return /* @__PURE__ */ a(H, {});
  const ee = (u, g, b) => u.map((i, x) => /* @__PURE__ */ C(
    "div",
    {
      className: "node-item",
      children: [
        /* @__PURE__ */ a(
          "input",
          {
            className: "tree-hidden",
            type: "checkbox",
            id: `fold-${i.id}`,
            name: "node-fold"
          }
        ),
        /* @__PURE__ */ C(
          "div",
          {
            className: "node-info",
            "data-root": i.root,
            "data-lock": i.lock,
            "data-hidden": i.hidden,
            "data-anchor": i.anchor,
            "data-id": i[K],
            "data-index": b - x,
            children: [
              /* @__PURE__ */ C(
                "div",
                {
                  className: `node-label ${i != null && i.selected ? "selected" : ""} ${i != null && i.edit ? "edit" : ""}`,
                  style: { color: i.hidden ? "#bebebe" : "inherit" },
                  draggable: !i.root && !i.lock && s,
                  onDragStart: (v) => D(v, i.id, i.anchor, b - x),
                  onDragEnter: (v) => T(v, i.anchor),
                  onDragOver: (v) => {
                    var P;
                    return O(v, i.root, i.slot, i.id, i.anchor, b - x, ((P = i == null ? void 0 : i.children) == null ? void 0 : P.length) || 0);
                  },
                  onDragLeave: (v) => q(v, i.anchor),
                  onDragEnd: (v) => be(v, i.anchor),
                  onDrop: (v) => ye(v, i.root, i.anchor),
                  onMouseDown: (v) => Ce(v, i.id, i.anchor, x),
                  children: [
                    /* @__PURE__ */ a(
                      pe,
                      {
                        node: i,
                        virtual: !0,
                        indent: g,
                        switcherIcon: h
                      }
                    ),
                    c && /* @__PURE__ */ a(
                      ft,
                      {
                        name: i.anchor.join(),
                        node: i
                      }
                    ),
                    /* @__PURE__ */ C("div", { className: "node-name", children: [
                      /* @__PURE__ */ a(
                        we,
                        {
                          Icom: l || i.icon,
                          node: i
                        }
                      ),
                      /* @__PURE__ */ a("span", { children: i.name })
                    ] })
                  ]
                }
              ),
              /* @__PURE__ */ a("div", { className: "fold-wrap", children: /* @__PURE__ */ a(
                pe,
                {
                  node: i,
                  virtual: !1,
                  indent: g,
                  switcherIcon: h
                }
              ) }),
              !i.root && /* @__PURE__ */ a(
                wt,
                {
                  node: i,
                  lock: f,
                  hidden: k,
                  prevent: et
                }
              )
            ]
          }
        ),
        i.children && /* @__PURE__ */ a(
          "div",
          {
            className: "node-children",
            style: {
              color: i.hidden ? "#bebebe" : "inherit"
            },
            children: ee(i.children.slice().reverse(), g.concat([0]), i.children.length - 1)
          }
        )
      ]
    },
    i[K]
  ));
  return /* @__PURE__ */ a(H, { children: ee(L.slice().reverse(), [0], L.length - 1) });
}, yt = (e) => {
  const { mouseEnter: n, mouseLeave: t, copy: o, cut: r, paste: s, remove: c, rightClick: l, handleTreeMouseDown: h } = R(), { data: d, theme: m } = e, [w, M] = xe(), E = ce(null), S = ce(null), L = Q((j) => j.tree.treeData), N = fe();
  return Ne(() => {
    if (!(!d || d.length === 0))
      return Re(e), M(A()), N(ot(ke(d, []))), document.documentElement.addEventListener("mousedown", h), () => {
        document.documentElement.removeEventListener("mousedown", h);
      };
  }, [d]), w ? /* @__PURE__ */ C(
    "section",
    {
      className: je(
        w.foldIconDisplay === _.always ? "tree-fold-show" : "",
        m ? `theme-${m}-tree` : "theme-default-tree"
      ),
      ref: S,
      style: w.style,
      onMouseEnter: n,
      onMouseLeave: t,
      onContextMenu: l,
      children: [
        /* @__PURE__ */ C("div", { className: "tree-container", children: [
          /* @__PURE__ */ a(
            bt,
            {
              ...w,
              data: L,
              lineRef: E,
              containerRef: S
            }
          ),
          /* @__PURE__ */ a(
            "div",
            {
              ref: E,
              className: "tree-drop-line"
            }
          )
        ] }),
        /* @__PURE__ */ a(
          pt,
          {
            ...w,
            copy: o,
            cut: r,
            paste: s,
            remove: c
          }
        )
      ]
    }
  ) : /* @__PURE__ */ a(H, {});
}, Ct = Se({
  reducer: {
    tree: at
  }
});
const jt = (e) => /* @__PURE__ */ a(Ee, { store: Ct, children: /* @__PURE__ */ a(yt, { ...e }) });
export {
  jt as default
};
